import javax.swing.JFrame;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Component;
import java.awt.BorderLayout;
import javax.swing.JTable;
import javax.swing.table.TableModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.JTextArea;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.JSeparator;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JLabel;
import java.awt.Color;

public class GE_FindFunc_Visual_PointsEdit {

	private JFrame frmEditPoints;
	private JTable table;
	private JTextArea textArea;
	private JButton btnAddPointsFrom;
	private JButton btnRemoveSelected;
	private JButton btnAdd;
	private JButton btnSelectAll;
	private DefaultTableModel pointsModel;
	private JSeparator separator;
	private JButton btnOk;
	private JLabel lblError;

	/**
	 * Create the application.
	 */
	public GE_FindFunc_Visual_PointsEdit(DefaultTableModel pointsModel) {
		this.pointsModel = pointsModel;
		table = new JTable(this.pointsModel);
		table.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent arg0) {
				String s =(String.valueOf(arg0.getKeyChar()));
				try  
				  {  
				    Double.parseDouble(s);  
				  } catch(Exception e) {
					  //arg0.setKeyChar(KeyEvent.CHAR_UNDEFINED);
					  arg0.consume();
				  }
			}
		});
		initialize();
		frmEditPoints.setVisible(true);
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmEditPoints = new JFrame();
		frmEditPoints.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		frmEditPoints.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				if(checkTableData()) frmEditPoints.dispose();
			}
		});
		frmEditPoints.setResizable(false);
		frmEditPoints.setTitle("Edit points");
		frmEditPoints.setBounds(100, 100, 450, 588);
		frmEditPoints.getContentPane().setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setBounds(10, 80, 135, 390);
		
		frmEditPoints.getContentPane().add(scrollPane);
		
		textArea = new JTextArea();
		textArea.append("1	0.5\r\n" + 
				"2	0.666666667\r\n" + 
				"3	0.75\r\n" + 
				"4	0.8\r\n" + 
				"5	0.833333333\r\n" + 
				"6	0.857142857\r\n" + 
				"7	0.875\r\n" + 
				"8	0.888888889\r\n" + 
				"9	0.9\r\n" + 
				"");

		JScrollPane scrollPane1 = new JScrollPane(textArea);
		scrollPane1.setBounds(155, 12, 269, 458);
		frmEditPoints.getContentPane().add(scrollPane1);
		
		btnAddPointsFrom = new JButton("Add Points from text area");
		btnAddPointsFrom.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addTextAreaPoints();
			}
		});
		btnAddPointsFrom.setBounds(238, 481, 186, 23);
		frmEditPoints.getContentPane().add(btnAddPointsFrom);
		
		btnRemoveSelected = new JButton("Remove Selected");
		btnRemoveSelected.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeFromTable();
			}
		});
		btnRemoveSelected.setBounds(10, 46, 135, 23);
		frmEditPoints.getContentPane().add(btnRemoveSelected);
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addPoint();
			}
		});
		btnAdd.setBounds(10, 481, 135, 23);
		frmEditPoints.getContentPane().add(btnAdd);
		
		btnSelectAll = new JButton("Select All");
		btnSelectAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				table.selectAll();
				
			}
		});
		btnSelectAll.setBounds(10, 12, 135, 23);
		frmEditPoints.getContentPane().add(btnSelectAll);
		
		separator = new JSeparator();
		separator.setBounds(10, 515, 414, 2);
		frmEditPoints.getContentPane().add(separator);
		
		btnOk = new JButton("Ok");
		btnOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(checkTableData()) frmEditPoints.dispose();
			}
		});
		btnOk.setBounds(335, 528, 89, 23);
		frmEditPoints.getContentPane().add(btnOk);
		
		lblError = new JLabel("");
		lblError.setForeground(Color.RED);
		lblError.setBounds(10, 532, 315, 14);
		frmEditPoints.getContentPane().add(lblError);
	}

	protected boolean checkTableData() {
		for(int i = 0; i < pointsModel.getRowCount(); i++) {
			String x, y;
			if(pointsModel.getValueAt(i, 0).getClass() == String.class) {
				x = (String) pointsModel.getValueAt(i, 0);
				if(x.isEmpty()) {
					lblError.setText("Table must not contain empty fields!");
					return false;
				}
			}
			if(pointsModel.getValueAt(i, 1).getClass() == String.class) {
				y = (String) pointsModel.getValueAt(i, 1);
				if(y.isEmpty()) {
					lblError.setText("Table must not contain empty fields!");
					return false;
				}
			}
		}
		return true;
	}

	protected void addTextAreaPoints() {
		DefaultTableModel model = (DefaultTableModel) table.getModel();
		//rozdelime podle radku, prazdne radky by mely byt preskoceny
		String[] s = textArea.getText().split("[\\r\\n]+");
		for (String line : s) {
			//sice by zde nemely byt prazdne radky, presto vsak znovu zkontrolujeme
			if(!line.isEmpty()) {
				try {
					String[] numbers = line.split("\\s+");
					double x = Double.parseDouble(numbers[0]);
					double y = Double.parseDouble(numbers[1]);
					model.addRow(new Object[] { x, y});
				} catch (Exception e) {
					//pokud se nepodarilo parsovat radek (napr nevhodne znak), nedelame nic, jdeme dal
				}
				
			}
		}
		
	}

	protected void removeFromTable() {
		   int[] rows = table.getSelectedRows();
		   for(int i=0;i<rows.length;i++){
			     pointsModel.removeRow(rows[i]-i);
			   }
	}

	protected void addPoint() {
		pointsModel.addRow(new Object[] { "", ""});
		
	}
}
