package outputs;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import global.GlobalParams;

public class FitnessPanel extends JPanel {
	// potrebujeme pouze jednu instanci, ke ktere pristupuje vice trid, proto
	// pouziejeme navrhovy vzor singleton
	private static FitnessPanel instance;

	private int oldX = -1;
	private int oldY = -1;
	private int newX = -1;
	private int newY = -1;
	private double xMax = -1, yMax = -1;
	private final double yCrop = 20, xCrop = 10;

	private FitnessPanel() {
	}

	public static FitnessPanel getInstance() {
		if (instance == null) {
			instance = new FitnessPanel();
		}
		return instance;
	}
	
	public void clearInstance() {
		instance.oldX = -1;
		instance.oldY = -1;
		instance.newX = -1;
		instance.newY = -1;
		instance.xMax = -1; 
		instance.yMax = -1;
	}

	public void init() {
		SwingUtilities.invokeLater(() -> {
			SwingUtilities.invokeLater(() -> {
				SwingUtilities.invokeLater(() -> {
					SwingUtilities.invokeLater(() -> {
						Graphics gr = instance.getGraphics();
						gr.fillRect(0, 0, this.getWidth(), this.getHeight());
						clearInstance();
					});
				});
			});
		});
	}

	public int getNewX() {
		return instance.newX;
	}

	public void setNewX(double newX) {
		if (instance.xMax == -1) {
			instance.xMax = GlobalParams.numberOfGenerations;
		}
		int x = (int) ((((instance.getWidth()-(xCrop*2)) * newX) / instance.xMax)+ xCrop);
		if (instance.oldX == -1)
			instance.oldX = x;
		instance.newX = x;
	}

	public int getNewY() {
		return instance.newY;
	}

	public void setNewY(double newY) {
		if (instance.yMax == -1) {
			instance.yMax = newY;
		}
		int y = (int) ((((instance.getHeight()-(yCrop*2)) * newY) / instance.yMax) + yCrop);
		y = instance.getHeight() - y;

		if (instance.oldY == -1)
			instance.oldY = y;
		instance.newY = y;
	}

	public void draw() {
		Graphics gr = instance.getGraphics();
		
		gr.setColor(Color.green);
		gr.drawRect(oldX-1, oldY-1, 2, 2);
		gr.drawRect(newX-1, newY-1, 2, 2);
		gr.drawRect(oldX-2, oldY-2, 4, 4);
		gr.drawRect(newX-2, newY-2, 4, 4);
		gr.setColor(Color.white);
			gr.drawLine(oldX, oldY, newX, newY);
			oldX = newX;
			oldY = newY;
	}

}
