package outputs;

import javax.swing.JTextArea;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

public class OutputConsole extends JTextArea {
	
	//potrebujeme pouze jednu instanci, ke ktere pristupuje vice trid, proto pouziejeme navrhovy vzor singleton
	private static OutputConsole instance;
	
	private OutputConsole(){}
	
	public static OutputConsole getInstance(){
	    if (instance == null) {
	        instance = new OutputConsole();
	        instance.setEditable(false);
	    }
        return instance;
    }
	
	public void writeNewLine(String line, boolean sysout) {
		instance.append(line);
		instance.append("\n");
		instance.setCaretPosition(instance.getDocument().getLength());
		if(sysout)
			System.out.println(line);
	}
}
