package outputs;

import java.awt.Color;
import java.awt.Graphics;

import javax.script.ScriptException;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import fitness.FindFunc_Fitness;

public class ResultPanel extends JPanel {

	private String func;
	private double[] xS;
	private double[] yS;
	private int yCrop = 10; //180 | -20 | 130
	private int xCrop = 5; //180 | -20 | 130
	private double xMin,xMax,yMin,yMax;
	private double addToX, addToY = 0;
	
	public void clear() {
		Graphics gr = this.getGraphics();
		gr.fillRect(0, 0, this.getWidth(), this.getHeight());
		xMin = xS[0]; 
		xMax = xS[0]; 
		yMin = yS[0]; 
		yMax = yS[0]; 
		for(double x : xS) {
			if(xMin > x) xMin = x;
			if(xMax < x) xMax = x;
		}
		for(double y : yS) {
			if(yMin > y) yMin = y;
			if(yMax < y) yMax = y;
		}
		if(xMin < 0) addToX = Math.abs(xMin);
		if(yMin < 0) addToY = Math.abs(yMin);
	}
	
	public void init() {
		SwingUtilities.invokeLater(() -> {
			SwingUtilities.invokeLater(() -> {
				SwingUtilities.invokeLater(() -> {
					SwingUtilities.invokeLater(() -> {
						clear();
						try {
							if(func!=null)
								drawFunction();
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						paintPoints();
					});
				});
			});
		});
	}
	
	public void paintPoints() {
		Graphics gr = this.getGraphics();
		gr.setColor(Color.white);
		for(int i = 0; i < xS.length; i++) {
			int x, y;
			x = (int)((((this.getWidth()-(xCrop*2))*(xS[i]+addToX))/(xMin+xMax+addToX+addToX)))+xCrop;
			y = (int)((((this.getHeight()-(yCrop*2))*(yS[i]+addToY))/(yMin+yMax+addToY+addToY)))+yCrop;
			y = this.getHeight() - y;
			//gr.drawRect(x-1, y-1, 2, 2);
			gr.drawRect(x-2, y-2, 4, 4);
		}
	}
	
	
	public void drawFunction() throws ScriptException {
		Graphics gr = this.getGraphics();
		gr.setColor(Color.green);
		//int multiplier = 1;
		boolean lastYset = false;
		int lastY = 0;
		/*IntStream.range(0, frame.getWidth()).parallel().forEach(
				x -> {
					double x1, y1;
					//x1=((((((double)x/10))-xCrop)*(xMin+xMax+addToX+addToX))/(frame.getWidth()-(2*xCrop)));
					x1 = (((((double)x)-xCrop)*(xMin+xMax+addToX+addToX))/(frame.getWidth()-(2*xCrop))) - addToX;
					try {
						y1 = FindFunc_Fitness.RunnableEval.computeValue(x1, func);
						
						int y = (int)((((frame.getHeight()-(yCrop*2))*(y1+addToY))/(yMin+yMax+addToY+addToY)))+yCrop;
						y = frame.getHeight() - y;
						gr.drawRect((x), y, 0, 0);
					} catch (ScriptException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
		);*/
		for (int x = 0; x < this.getWidth(); x++) {
			double x1, y1;
			//x1=((((((double)x/10))-xCrop)*(xMin+xMax+addToX+addToX))/(frame.getWidth()-(2*xCrop)));
			x1 = (((((double)x)-xCrop)*(xMin+xMax+addToX+addToX))/(this.getWidth()-(2*xCrop))) - addToX;
			try {
				y1 = FindFunc_Fitness.RunnableEval.computeValue(x1, func);
				
				int y = (int)((((this.getHeight()-(yCrop*2))*(y1+addToY))/(yMin+yMax+addToY+addToY)))+yCrop;
				y = this.getHeight() - y;
				if(!lastYset) {
					lastY = y;
					lastYset = true;
				}
				gr.drawRect(x, y, 0, 0);
				if(Math.abs(lastY - y) > 1) {
					gr.drawLine((x-1), lastY, x, y);
				}
				lastY = y;
			} catch (ScriptException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public String getFunc() {
		return func;
	}

	public void setFunc(String func) {
		this.func = func;
	}

	public double[] getxS() {
		return xS;
	}

	public void setxS(double[] xS) {
		this.xS = xS;
	}

	public double[] getyS() {
		return yS;
	}

	public void setyS(double[] yS) {
		this.yS = yS;
	}

	public int getyCrop() {
		return yCrop;
	}

	public void setyCrop(int yCrop) {
		this.yCrop = yCrop;
	}

	public int getxCrop() {
		return xCrop;
	}

	public void setxCrop(int xCrop) {
		this.xCrop = xCrop;
	}

	public double getxMin() {
		return xMin;
	}

	public void setxMin(double xMin) {
		this.xMin = xMin;
	}

	public double getxMax() {
		return xMax;
	}

	public void setxMax(double xMax) {
		this.xMax = xMax;
	}

	public double getyMin() {
		return yMin;
	}

	public void setyMin(double yMin) {
		this.yMin = yMin;
	}

	public double getyMax() {
		return yMax;
	}

	public void setyMax(double yMax) {
		this.yMax = yMax;
	}

	public double getAddToX() {
		return addToX;
	}

	public void setAddToX(double addToX) {
		this.addToX = addToX;
	}

	public double getAddToY() {
		return addToY;
	}

	public void setAddToY(double addToY) {
		this.addToY = addToY;
	}
	
}
