package utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import global.GlobalParams;

public class GrammarReader {
	private List<String> headers;
	private List<List<String>> rules;
	
	public GrammarReader() throws IOException {
		FileReader reader = new FileReader(GlobalParams.grammarFilePath);
		BufferedReader buffer = new BufferedReader(reader);
		createRules(buffer);
	}

	private void createRules(BufferedReader buffer) throws IOException {
		headers = new ArrayList<>();
		rules = new ArrayList<>();
		String line;
		while((line = buffer.readLine()) != null)
			if(!line.isEmpty())
			{
				line = line.replaceAll("\\s","");
				String rule[] = line.split("::=");
				headers.add(rule[0]);
				

				String lineRule[] = rule[1].split("\\|");
				List<String> rulesList = new ArrayList<>();
				
				for(int i = 0; i < lineRule.length; i++) 
					rulesList.add(lineRule[i]);
				
				rules.add(rulesList);
			}
	}

	public List<String> getHeaders() {
		return headers;
	}

	public List<List<String>> getRules() {
		return rules;
	}
	
}
